﻿-- Author      : Nogarder
-- Create Date : 2013/4/20 16:51:51
local max=max
local random=random
local abs=abs
--
NPA.CombatTextManager={}
--
local NPA_TextureManager_ManageTexture3=NPA.TextureManager.ManageTexture3
local NPA_FontManager_ManageFont3=NPA.FontManager.ManageFont3
local NPA_Color_GetColorBySpellSchool=NPA.Color.GetColorBySpellSchool
--
local CombatTextList={}
local CurrentCount=1
local MaxText=100 --max 100
--
local GetXY={
	--0=fixed ,1=topleft 2=topright 3=bottomleft 4=bottomright 5=top  6=bottom 7=left 8=right
	[0]=function(dx,dy)
		return dx,dy
	end,
	[1]=function(dx,dy)
		return -random()*abs(dx),random()*abs(dy)
	end,
	[2]=function(dx,dy)
		return random()*abs(dx),random()*abs(dy)
	end,
	[3]=function(dx,dy)
		return -random()*abs(dx),-random()*abs(dy)
	end,
	[4]=function(dx,dy)
		return random()*abs(dx),-random()*abs(dy)
	end,
	[5]=function(dx,dy)
		return (random()*2-1)*abs(dx),random()*abs(dy)
	end,
	[6]=function(dx,dy)
		return (random()*2-1)*abs(dx),-random()*abs(dy)
	end,
	[7]=function(dx,dy)
		return -random()*abs(dx),(random()*2-1)*abs(dy)
	end,
	[8]=function(dx,dy)
		return random()*abs(dx),(random()*2-1)*abs(dy)
	end
}
--
local TextOnUpdate=function(self,elapse)
	if(not self.Parent:IsShown())then
		self:Hide()
		return
	end
	--
	self.AnimationTime=self.AnimationTime-elapse --check time
	if(self.AnimationTime<0)then
		self.AnimationCurrent=self.AnimationCurrent+1
		local animation=self.Animation[self.AnimationCurrent]
		if(not animation)then --no more animation, hide it
			self:Hide()
			return
		end
		--more animation, init it
		self.SpeedX,self.SpeedY=GetXY[animation.SpeedType](animation.SpeedX,animation.SpeedY)
		self.AccX,self.AccY=GetXY[animation.AccType](animation.AccX,animation.AccY)
		--
		self.AlphaStep=(animation.EndAlpha-animation.StartAlpha)/animation.Lasts
		self.EndAlpha=animation.EndAlpha
		self.SizeStep=(animation.EndSize-animation.StartSize)/animation.Lasts
		self.EndSize=animation.EndSize
		self.AnimationTime=animation.Lasts
		self.ShakeRange=animation.ShakeRange
		self:SetFrameLevel(animation.FrameLevel+self:GetParent():GetFrameLevel())
	end
	--init animation
	self.PosX=self.PosX+self.SpeedX*elapse
	self.PosY=self.PosY+self.SpeedY*elapse
	self.SpeedX=self.SpeedX+self.AccX
	self.SpeedY=self.SpeedY+self.AccY
	--
	if(self.ShakeRange>0)then
		self:SetPoint("CENTER",self.Parent,"CENTER",self.PosX+(random()-0.5)*2*self.ShakeRange,self.PosY+(random()-0.5)*2*self.ShakeRange)
	else
		self:SetPoint("CENTER",self.Parent,"CENTER",self.PosX,self.PosY)
	end
	--
	self:SetAlpha(self.EndAlpha-self.AlphaStep*self.AnimationTime)
	self:SetScale(self.EndSize-self.SizeStep*self.AnimationTime)
	--
end
--
local CreateText=function()
	local frame=CreateFrame("Frame",nil,UIParent)
	frame:SetFrameStrata("TOOLTIP")
	frame:EnableMouse(false)
	frame:SetWidth(1)
	frame:SetHeight(1)
	frame:Hide()
	frame:SetScript("OnUpdate",TextOnUpdate)

	local icon=frame:CreateTexture(nil,"OVERLAY")
	icon:SetWidth(10)
	icon:SetHeight(10)
	icon:SetPoint("LEFT",frame,"LEFT",0,0)

	local text=frame:CreateFontString(nil,"OVERLAY")
	text:SetPoint("CENTER",frame,"CENTER",0,0)
	text:SetFont(GameFontNormal:GetFont())
	text:SetPoint("RIGHT",frame,"RIGHT",0,0)

	local background=frame:CreateTexture(nil,"BACKGROUND")
	background:SetPoint("TOPLEFT",frame,"TOPLEFT",0,0)
	background:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",0,0)

	frame.Text=text
	frame.Icon=icon
	frame.Background=background
	return frame
end

NPA.CombatTextManager.AddText=function(parent,icon,text,school,setting,animation)
	--
	if((not animation) or (not parent))then
		return
	end
	--
	if(not CombatTextList[CurrentCount])then
		CombatTextList[CurrentCount]=CreateText()
	end
	--
	local frame=CombatTextList[CurrentCount]
	frame:SetPoint("CENTER",parent,"BOTTOMLEFT",0,0)
	--
	frame.Text:SetText(text)
	if(text==nil)then
		frame.Text:SetWidth(1)
		frame.Text:SetHeight(1)
	else
		NPA_FontManager_ManageFont3(frame.Text,setting.FontProfileName,setting.TextWidth,setting.TextHeight)
		local color=NPA_Color_GetColorBySpellSchool(school)
		frame.Text:SetTextColor(color.R,color.G,color.B,color.A)
	end
	--
	frame.Icon:SetTexture(icon)
	if(icon==nil)then
		frame.Icon:SetWidth(1)
		frame.Icon:SetHeight(1)
	else
		frame.Icon:SetWidth(setting.IconSize)
		frame.Icon:SetHeight(setting.IconSize)
	end
	--
	frame.Background:SetPoint("TOPLEFT",frame,"TOPLEFT",-setting.BGWidth,setting.BGHeight)
	frame.Background:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",setting.BGWidth,-setting.BGHeight)
	NPA_TextureManager_ManageTexture3(frame.Background,setting.BGFileName,setting.BGColor)
	--
	frame:SetWidth(frame.Text:GetWidth()+frame.Icon:GetWidth()) --text width could be variable
	frame:SetHeight(max(setting.TextHeight,frame.Icon:GetHeight()))
	--init animation
	frame.Animation=animation
	frame.AnimationTime=0
	frame.AnimationCurrent=0
	frame.PosX=0
	frame.PosY=0
	--
	frame.Parent=parent
	frame:SetPoint("CENTER",parent,"CENTER",0,0)
	frame:SetAlpha(0)
	frame:SetScale(0.1)
	frame:Show()
	--
	CurrentCount=CurrentCount+1
	if(CurrentCount>MaxText)then
		CurrentCount=1
	end
end

